/* tslint:disable */
/* eslint-disable */
// @generated
// This file was automatically generated and should not be edited.

// ====================================================
// GraphQL query operation: SearchGames
// ====================================================

export interface SearchGames_searchFor_games_items {
  __typename: 'Game';
  /**
   * The name of the game. This string is untranslated.
   * This field should only be used in limited occassions, like tracking and URLs.
   * You should use displayName for all all game names shown to the users.
   */
  name: string;
  /**
   * The translated game name used for display purposes.
   * Use name for tracking props or URLs.
   */
  displayName: string;
  /**
   * The game's unique Twitch identifier.
   * It is used to associate games with product offers.
   */
  id: string;
  /**
   * URL to a box art image.
   * The image dimensions are specifiable via the `height` and `width` parameters.
   *
   * If `height` or `width` are not specified, the URL will contain
   * the template strings `{height}` and/or `{width}` in their respective places.
   */
  boxArtURL: string | null;
}

export interface SearchGames_searchFor_games {
  __typename: 'SearchForResultGames';
  /**
   * List of matching game results.
   */
  items: SearchGames_searchFor_games_items[] | null;
}

export interface SearchGames_searchFor {
  __typename: 'SearchFor';
  /**
   * Contains results for games.
   */
  games: SearchGames_searchFor_games | null;
}

export interface SearchGames {
  /**
   * Get gql search results for a user's query.
   */
  searchFor: SearchGames_searchFor | null;
}

export interface SearchGamesVariables {
  query: string;
}

/* tslint:disable */
/* eslint-disable */
// @generated
// This file was automatically generated and should not be edited.

// ====================================================
// GraphQL query operation: getGameInfo
// ====================================================

export interface getGameInfo_searchFor_games_items {
  __typename: 'Game';
  /**
   * The game's unique GiantBomb identifier.
   */
  giantBombID: string | null;
}

export interface getGameInfo_searchFor_games {
  __typename: 'SearchForResultGames';
  /**
   * List of matching game results.
   */
  items: getGameInfo_searchFor_games_items[] | null;
}

export interface getGameInfo_searchFor {
  __typename: 'SearchFor';
  /**
   * Contains results for games.
   */
  games: getGameInfo_searchFor_games | null;
}

export interface getGameInfo {
  /**
   * Get gql search results for a user's query.
   */
  searchFor: getGameInfo_searchFor | null;
}

export interface getGameInfoVariables {
  query: string;
}

/* tslint:disable */
/* eslint-disable */
// @generated
// This file was automatically generated and should not be edited.

// ====================================================
// GraphQL query operation: getExtensionByClientId
// ====================================================

export interface getExtensionByClientId_extension {
  __typename: 'Extension';
  /**
   * The name of the extension specified by the developer's extension manifest
   * (max-length: 40 characters).
   */
  name: string;
  /**
   * The author of the extension as specified by the developer's extension manifest.
   */
  authorName: string;
  /**
   * The client ID of the extension. Also used as the non-composite, non-unique ID of an extension internally.
   */
  clientID: string;
}

export interface getExtensionByClientId {
  /**
   * Get an Extension by ID. Optionally, provide a specific version. If no version is provided,
   * the released version of that extension is returned.
   */
  extension: getExtensionByClientId_extension | null;
}

export interface getExtensionByClientIdVariables {
  clientId: string;
}

/* tslint:disable */
/* eslint-disable */
// @generated
// This file was automatically generated and should not be edited.

// ====================================================
// GraphQL query operation: listExtensions
// ====================================================

export interface listExtensions_extensions_edges_node {
  __typename: 'Extension';
  /**
   * The name of the extension specified by the developer's extension manifest
   * (max-length: 40 characters).
   */
  name: string;
  /**
   * The client ID of the extension. Also used as the non-composite, non-unique ID of an extension internally.
   */
  clientID: string;
  /**
   * The author of the extension as specified by the developer's extension manifest.
   */
  authorName: string;
}

export interface listExtensions_extensions_edges {
  __typename: 'ExtensionEdge';
  /**
   * Node represents the extension for the current edge.
   */
  node: listExtensions_extensions_edges_node;
  /**
   * Cursor represents the position of the current edge/node.
   */
  cursor: any;
}

export interface listExtensions_extensions_pageInfo {
  __typename: 'PageInfo';
  hasNextPage: boolean;
  hasPreviousPage: boolean;
}

export interface listExtensions_extensions {
  __typename: 'ExtensionConnection';
  /**
   * The list of extensions in this page.
   */
  edges: listExtensions_extensions_edges[];
  /**
   * Information about this page of extensions.
   */
  pageInfo: listExtensions_extensions_pageInfo;
  /**
   * The total number of extensions in the larger collection.
   */
  totalCount: number;
}

export interface listExtensions {
  /**
   * Search extensions by text found in the Extension name, description or summary. The results are
   * always returned in order of popularity. By default, all RELEASED and IN_TEST extensions are returned.
   * Pass RELEASED as the value of 'state' to only return extensions in the RELEASED state.
   */
  extensions: listExtensions_extensions | null;
}

export interface listExtensionsVariables {
  cursor?: any | null;
  search?: string | null;
}

/* tslint:disable */
/* eslint-disable */
// @generated
// This file was automatically generated and should not be edited.

// ====================================================
// GraphQL query operation: getGameDetails
// ====================================================

export interface getGameDetails_game {
  __typename: 'Game';
  /**
   * The translated game name used for display purposes.
   * Use name for tracking props or URLs.
   */
  displayName: string;
  /**
   * The name of the game. This string is untranslated.
   * This field should only be used in limited occassions, like tracking and URLs.
   * You should use displayName for all all game names shown to the users.
   */
  name: string;
  /**
   * URL to a box art image.
   * The image dimensions are specifiable via the `height` and `width` parameters.
   *
   * If `height` or `width` are not specified, the URL will contain
   * the template strings `{height}` and/or `{width}` in their respective places.
   */
  boxArtURL: string | null;
  /**
   * The game's unique GiantBomb identifier.
   */
  giantBombID: string | null;
  /**
   * URL to a cover image.
   * The image dimensions are specifiable via the `height` and `width` parameters.
   *
   * If `height` or `width` are not specified, the URL will contain
   * the template strings `{height}` and/or `{width}` in their respective places.
   */
  coverURL: string | null;
}

export interface getGameDetails {
  /**
   * Get a single game as identified by its name or ID. At least one parameter must be provided.
   */
  game: getGameDetails_game | null;
}

export interface getGameDetailsVariables {
  id: string;
}

/* tslint:disable */
/* eslint-disable */
// @generated
// This file was automatically generated and should not be edited.

//==============================================================
// START Enums and Input Objects
//==============================================================

//==============================================================
// END Enums and Input Objects
//==============================================================
