// Code generated by counterfeiter. DO NOT EDIT.
package companiesfakes

import (
	"context"
	"sync"

	"code.justin.tv/devrel/devsite-rbac/backend/companies"
	"code.justin.tv/devrel/devsite-rbac/rpc/rbacrpc"
)

type FakeCBackender struct {
	FindCompaniesStub        func(ctx context.Context, params *rbacrpc.ListCompaniesRequest) (*rbacrpc.ListCompaniesResponse, error)
	findCompaniesMutex       sync.RWMutex
	findCompaniesArgsForCall []struct {
		ctx    context.Context
		params *rbacrpc.ListCompaniesRequest
	}
	findCompaniesReturns struct {
		result1 *rbacrpc.ListCompaniesResponse
		result2 error
	}
	findCompaniesReturnsOnCall map[int]struct {
		result1 *rbacrpc.ListCompaniesResponse
		result2 error
	}
	SearchCompaniesStub        func(ctx context.Context, query string, limit uint64) (*rbacrpc.SearchCompaniesResponse, error)
	searchCompaniesMutex       sync.RWMutex
	searchCompaniesArgsForCall []struct {
		ctx   context.Context
		query string
		limit uint64
	}
	searchCompaniesReturns struct {
		result1 *rbacrpc.SearchCompaniesResponse
		result2 error
	}
	searchCompaniesReturnsOnCall map[int]struct {
		result1 *rbacrpc.SearchCompaniesResponse
		result2 error
	}
	SelectCompaniesStub        func(ctx context.Context, ids []string) (map[string]*rbacrpc.Company, error)
	selectCompaniesMutex       sync.RWMutex
	selectCompaniesArgsForCall []struct {
		ctx context.Context
		ids []string
	}
	selectCompaniesReturns struct {
		result1 map[string]*rbacrpc.Company
		result2 error
	}
	selectCompaniesReturnsOnCall map[int]struct {
		result1 map[string]*rbacrpc.Company
		result2 error
	}
	SelectCompanyStub        func(ctx context.Context, id string) (*rbacrpc.Company, error)
	selectCompanyMutex       sync.RWMutex
	selectCompanyArgsForCall []struct {
		ctx context.Context
		id  string
	}
	selectCompanyReturns struct {
		result1 *rbacrpc.Company
		result2 error
	}
	selectCompanyReturnsOnCall map[int]struct {
		result1 *rbacrpc.Company
		result2 error
	}
	SelectCompanyByCompanyNameStub        func(ctx context.Context, name string) (*rbacrpc.Company, error)
	selectCompanyByCompanyNameMutex       sync.RWMutex
	selectCompanyByCompanyNameArgsForCall []struct {
		ctx  context.Context
		name string
	}
	selectCompanyByCompanyNameReturns struct {
		result1 *rbacrpc.Company
		result2 error
	}
	selectCompanyByCompanyNameReturnsOnCall map[int]struct {
		result1 *rbacrpc.Company
		result2 error
	}
	InsertCompanyStub        func(ctx context.Context, params *companies.CreateRequest) (*rbacrpc.Company, error)
	insertCompanyMutex       sync.RWMutex
	insertCompanyArgsForCall []struct {
		ctx    context.Context
		params *companies.CreateRequest
	}
	insertCompanyReturns struct {
		result1 *rbacrpc.Company
		result2 error
	}
	insertCompanyReturnsOnCall map[int]struct {
		result1 *rbacrpc.Company
		result2 error
	}
	UpdateCompanyStub        func(ctx context.Context, params *rbacrpc.UpdateCompanyRequest) (*rbacrpc.Company, error)
	updateCompanyMutex       sync.RWMutex
	updateCompanyArgsForCall []struct {
		ctx    context.Context
		params *rbacrpc.UpdateCompanyRequest
	}
	updateCompanyReturns struct {
		result1 *rbacrpc.Company
		result2 error
	}
	updateCompanyReturnsOnCall map[int]struct {
		result1 *rbacrpc.Company
		result2 error
	}
	DeleteCompanyStub        func(ctx context.Context, params *rbacrpc.DeleteCompanyRequest) error
	deleteCompanyMutex       sync.RWMutex
	deleteCompanyArgsForCall []struct {
		ctx    context.Context
		params *rbacrpc.DeleteCompanyRequest
	}
	deleteCompanyReturns struct {
		result1 error
	}
	deleteCompanyReturnsOnCall map[int]struct {
		result1 error
	}
	CompanyExistsWithIdentifierStub        func(ctx context.Context, identifier string) (bool, error)
	companyExistsWithIdentifierMutex       sync.RWMutex
	companyExistsWithIdentifierArgsForCall []struct {
		ctx        context.Context
		identifier string
	}
	companyExistsWithIdentifierReturns struct {
		result1 bool
		result2 error
	}
	companyExistsWithIdentifierReturnsOnCall map[int]struct {
		result1 bool
		result2 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeCBackender) FindCompanies(ctx context.Context, params *rbacrpc.ListCompaniesRequest) (*rbacrpc.ListCompaniesResponse, error) {
	fake.findCompaniesMutex.Lock()
	ret, specificReturn := fake.findCompaniesReturnsOnCall[len(fake.findCompaniesArgsForCall)]
	fake.findCompaniesArgsForCall = append(fake.findCompaniesArgsForCall, struct {
		ctx    context.Context
		params *rbacrpc.ListCompaniesRequest
	}{ctx, params})
	fake.recordInvocation("FindCompanies", []interface{}{ctx, params})
	fake.findCompaniesMutex.Unlock()
	if fake.FindCompaniesStub != nil {
		return fake.FindCompaniesStub(ctx, params)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.findCompaniesReturns.result1, fake.findCompaniesReturns.result2
}

func (fake *FakeCBackender) FindCompaniesCallCount() int {
	fake.findCompaniesMutex.RLock()
	defer fake.findCompaniesMutex.RUnlock()
	return len(fake.findCompaniesArgsForCall)
}

func (fake *FakeCBackender) FindCompaniesArgsForCall(i int) (context.Context, *rbacrpc.ListCompaniesRequest) {
	fake.findCompaniesMutex.RLock()
	defer fake.findCompaniesMutex.RUnlock()
	return fake.findCompaniesArgsForCall[i].ctx, fake.findCompaniesArgsForCall[i].params
}

func (fake *FakeCBackender) FindCompaniesReturns(result1 *rbacrpc.ListCompaniesResponse, result2 error) {
	fake.FindCompaniesStub = nil
	fake.findCompaniesReturns = struct {
		result1 *rbacrpc.ListCompaniesResponse
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) FindCompaniesReturnsOnCall(i int, result1 *rbacrpc.ListCompaniesResponse, result2 error) {
	fake.FindCompaniesStub = nil
	if fake.findCompaniesReturnsOnCall == nil {
		fake.findCompaniesReturnsOnCall = make(map[int]struct {
			result1 *rbacrpc.ListCompaniesResponse
			result2 error
		})
	}
	fake.findCompaniesReturnsOnCall[i] = struct {
		result1 *rbacrpc.ListCompaniesResponse
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) SearchCompanies(ctx context.Context, query string, limit uint64) (*rbacrpc.SearchCompaniesResponse, error) {
	fake.searchCompaniesMutex.Lock()
	ret, specificReturn := fake.searchCompaniesReturnsOnCall[len(fake.searchCompaniesArgsForCall)]
	fake.searchCompaniesArgsForCall = append(fake.searchCompaniesArgsForCall, struct {
		ctx   context.Context
		query string
		limit uint64
	}{ctx, query, limit})
	fake.recordInvocation("SearchCompanies", []interface{}{ctx, query, limit})
	fake.searchCompaniesMutex.Unlock()
	if fake.SearchCompaniesStub != nil {
		return fake.SearchCompaniesStub(ctx, query, limit)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.searchCompaniesReturns.result1, fake.searchCompaniesReturns.result2
}

func (fake *FakeCBackender) SearchCompaniesCallCount() int {
	fake.searchCompaniesMutex.RLock()
	defer fake.searchCompaniesMutex.RUnlock()
	return len(fake.searchCompaniesArgsForCall)
}

func (fake *FakeCBackender) SearchCompaniesArgsForCall(i int) (context.Context, string, uint64) {
	fake.searchCompaniesMutex.RLock()
	defer fake.searchCompaniesMutex.RUnlock()
	return fake.searchCompaniesArgsForCall[i].ctx, fake.searchCompaniesArgsForCall[i].query, fake.searchCompaniesArgsForCall[i].limit
}

func (fake *FakeCBackender) SearchCompaniesReturns(result1 *rbacrpc.SearchCompaniesResponse, result2 error) {
	fake.SearchCompaniesStub = nil
	fake.searchCompaniesReturns = struct {
		result1 *rbacrpc.SearchCompaniesResponse
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) SearchCompaniesReturnsOnCall(i int, result1 *rbacrpc.SearchCompaniesResponse, result2 error) {
	fake.SearchCompaniesStub = nil
	if fake.searchCompaniesReturnsOnCall == nil {
		fake.searchCompaniesReturnsOnCall = make(map[int]struct {
			result1 *rbacrpc.SearchCompaniesResponse
			result2 error
		})
	}
	fake.searchCompaniesReturnsOnCall[i] = struct {
		result1 *rbacrpc.SearchCompaniesResponse
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) SelectCompanies(ctx context.Context, ids []string) (map[string]*rbacrpc.Company, error) {
	var idsCopy []string
	if ids != nil {
		idsCopy = make([]string, len(ids))
		copy(idsCopy, ids)
	}
	fake.selectCompaniesMutex.Lock()
	ret, specificReturn := fake.selectCompaniesReturnsOnCall[len(fake.selectCompaniesArgsForCall)]
	fake.selectCompaniesArgsForCall = append(fake.selectCompaniesArgsForCall, struct {
		ctx context.Context
		ids []string
	}{ctx, idsCopy})
	fake.recordInvocation("SelectCompanies", []interface{}{ctx, idsCopy})
	fake.selectCompaniesMutex.Unlock()
	if fake.SelectCompaniesStub != nil {
		return fake.SelectCompaniesStub(ctx, ids)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.selectCompaniesReturns.result1, fake.selectCompaniesReturns.result2
}

func (fake *FakeCBackender) SelectCompaniesCallCount() int {
	fake.selectCompaniesMutex.RLock()
	defer fake.selectCompaniesMutex.RUnlock()
	return len(fake.selectCompaniesArgsForCall)
}

func (fake *FakeCBackender) SelectCompaniesArgsForCall(i int) (context.Context, []string) {
	fake.selectCompaniesMutex.RLock()
	defer fake.selectCompaniesMutex.RUnlock()
	return fake.selectCompaniesArgsForCall[i].ctx, fake.selectCompaniesArgsForCall[i].ids
}

func (fake *FakeCBackender) SelectCompaniesReturns(result1 map[string]*rbacrpc.Company, result2 error) {
	fake.SelectCompaniesStub = nil
	fake.selectCompaniesReturns = struct {
		result1 map[string]*rbacrpc.Company
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) SelectCompaniesReturnsOnCall(i int, result1 map[string]*rbacrpc.Company, result2 error) {
	fake.SelectCompaniesStub = nil
	if fake.selectCompaniesReturnsOnCall == nil {
		fake.selectCompaniesReturnsOnCall = make(map[int]struct {
			result1 map[string]*rbacrpc.Company
			result2 error
		})
	}
	fake.selectCompaniesReturnsOnCall[i] = struct {
		result1 map[string]*rbacrpc.Company
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) SelectCompany(ctx context.Context, id string) (*rbacrpc.Company, error) {
	fake.selectCompanyMutex.Lock()
	ret, specificReturn := fake.selectCompanyReturnsOnCall[len(fake.selectCompanyArgsForCall)]
	fake.selectCompanyArgsForCall = append(fake.selectCompanyArgsForCall, struct {
		ctx context.Context
		id  string
	}{ctx, id})
	fake.recordInvocation("SelectCompany", []interface{}{ctx, id})
	fake.selectCompanyMutex.Unlock()
	if fake.SelectCompanyStub != nil {
		return fake.SelectCompanyStub(ctx, id)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.selectCompanyReturns.result1, fake.selectCompanyReturns.result2
}

func (fake *FakeCBackender) SelectCompanyCallCount() int {
	fake.selectCompanyMutex.RLock()
	defer fake.selectCompanyMutex.RUnlock()
	return len(fake.selectCompanyArgsForCall)
}

func (fake *FakeCBackender) SelectCompanyArgsForCall(i int) (context.Context, string) {
	fake.selectCompanyMutex.RLock()
	defer fake.selectCompanyMutex.RUnlock()
	return fake.selectCompanyArgsForCall[i].ctx, fake.selectCompanyArgsForCall[i].id
}

func (fake *FakeCBackender) SelectCompanyReturns(result1 *rbacrpc.Company, result2 error) {
	fake.SelectCompanyStub = nil
	fake.selectCompanyReturns = struct {
		result1 *rbacrpc.Company
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) SelectCompanyReturnsOnCall(i int, result1 *rbacrpc.Company, result2 error) {
	fake.SelectCompanyStub = nil
	if fake.selectCompanyReturnsOnCall == nil {
		fake.selectCompanyReturnsOnCall = make(map[int]struct {
			result1 *rbacrpc.Company
			result2 error
		})
	}
	fake.selectCompanyReturnsOnCall[i] = struct {
		result1 *rbacrpc.Company
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) SelectCompanyByCompanyName(ctx context.Context, name string) (*rbacrpc.Company, error) {
	fake.selectCompanyByCompanyNameMutex.Lock()
	ret, specificReturn := fake.selectCompanyByCompanyNameReturnsOnCall[len(fake.selectCompanyByCompanyNameArgsForCall)]
	fake.selectCompanyByCompanyNameArgsForCall = append(fake.selectCompanyByCompanyNameArgsForCall, struct {
		ctx  context.Context
		name string
	}{ctx, name})
	fake.recordInvocation("SelectCompanyByCompanyName", []interface{}{ctx, name})
	fake.selectCompanyByCompanyNameMutex.Unlock()
	if fake.SelectCompanyByCompanyNameStub != nil {
		return fake.SelectCompanyByCompanyNameStub(ctx, name)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.selectCompanyByCompanyNameReturns.result1, fake.selectCompanyByCompanyNameReturns.result2
}

func (fake *FakeCBackender) SelectCompanyByCompanyNameCallCount() int {
	fake.selectCompanyByCompanyNameMutex.RLock()
	defer fake.selectCompanyByCompanyNameMutex.RUnlock()
	return len(fake.selectCompanyByCompanyNameArgsForCall)
}

func (fake *FakeCBackender) SelectCompanyByCompanyNameArgsForCall(i int) (context.Context, string) {
	fake.selectCompanyByCompanyNameMutex.RLock()
	defer fake.selectCompanyByCompanyNameMutex.RUnlock()
	return fake.selectCompanyByCompanyNameArgsForCall[i].ctx, fake.selectCompanyByCompanyNameArgsForCall[i].name
}

func (fake *FakeCBackender) SelectCompanyByCompanyNameReturns(result1 *rbacrpc.Company, result2 error) {
	fake.SelectCompanyByCompanyNameStub = nil
	fake.selectCompanyByCompanyNameReturns = struct {
		result1 *rbacrpc.Company
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) SelectCompanyByCompanyNameReturnsOnCall(i int, result1 *rbacrpc.Company, result2 error) {
	fake.SelectCompanyByCompanyNameStub = nil
	if fake.selectCompanyByCompanyNameReturnsOnCall == nil {
		fake.selectCompanyByCompanyNameReturnsOnCall = make(map[int]struct {
			result1 *rbacrpc.Company
			result2 error
		})
	}
	fake.selectCompanyByCompanyNameReturnsOnCall[i] = struct {
		result1 *rbacrpc.Company
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) InsertCompany(ctx context.Context, params *companies.CreateRequest) (*rbacrpc.Company, error) {
	fake.insertCompanyMutex.Lock()
	ret, specificReturn := fake.insertCompanyReturnsOnCall[len(fake.insertCompanyArgsForCall)]
	fake.insertCompanyArgsForCall = append(fake.insertCompanyArgsForCall, struct {
		ctx    context.Context
		params *companies.CreateRequest
	}{ctx, params})
	fake.recordInvocation("InsertCompany", []interface{}{ctx, params})
	fake.insertCompanyMutex.Unlock()
	if fake.InsertCompanyStub != nil {
		return fake.InsertCompanyStub(ctx, params)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.insertCompanyReturns.result1, fake.insertCompanyReturns.result2
}

func (fake *FakeCBackender) InsertCompanyCallCount() int {
	fake.insertCompanyMutex.RLock()
	defer fake.insertCompanyMutex.RUnlock()
	return len(fake.insertCompanyArgsForCall)
}

func (fake *FakeCBackender) InsertCompanyArgsForCall(i int) (context.Context, *companies.CreateRequest) {
	fake.insertCompanyMutex.RLock()
	defer fake.insertCompanyMutex.RUnlock()
	return fake.insertCompanyArgsForCall[i].ctx, fake.insertCompanyArgsForCall[i].params
}

func (fake *FakeCBackender) InsertCompanyReturns(result1 *rbacrpc.Company, result2 error) {
	fake.InsertCompanyStub = nil
	fake.insertCompanyReturns = struct {
		result1 *rbacrpc.Company
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) InsertCompanyReturnsOnCall(i int, result1 *rbacrpc.Company, result2 error) {
	fake.InsertCompanyStub = nil
	if fake.insertCompanyReturnsOnCall == nil {
		fake.insertCompanyReturnsOnCall = make(map[int]struct {
			result1 *rbacrpc.Company
			result2 error
		})
	}
	fake.insertCompanyReturnsOnCall[i] = struct {
		result1 *rbacrpc.Company
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) UpdateCompany(ctx context.Context, params *rbacrpc.UpdateCompanyRequest) (*rbacrpc.Company, error) {
	fake.updateCompanyMutex.Lock()
	ret, specificReturn := fake.updateCompanyReturnsOnCall[len(fake.updateCompanyArgsForCall)]
	fake.updateCompanyArgsForCall = append(fake.updateCompanyArgsForCall, struct {
		ctx    context.Context
		params *rbacrpc.UpdateCompanyRequest
	}{ctx, params})
	fake.recordInvocation("UpdateCompany", []interface{}{ctx, params})
	fake.updateCompanyMutex.Unlock()
	if fake.UpdateCompanyStub != nil {
		return fake.UpdateCompanyStub(ctx, params)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.updateCompanyReturns.result1, fake.updateCompanyReturns.result2
}

func (fake *FakeCBackender) UpdateCompanyCallCount() int {
	fake.updateCompanyMutex.RLock()
	defer fake.updateCompanyMutex.RUnlock()
	return len(fake.updateCompanyArgsForCall)
}

func (fake *FakeCBackender) UpdateCompanyArgsForCall(i int) (context.Context, *rbacrpc.UpdateCompanyRequest) {
	fake.updateCompanyMutex.RLock()
	defer fake.updateCompanyMutex.RUnlock()
	return fake.updateCompanyArgsForCall[i].ctx, fake.updateCompanyArgsForCall[i].params
}

func (fake *FakeCBackender) UpdateCompanyReturns(result1 *rbacrpc.Company, result2 error) {
	fake.UpdateCompanyStub = nil
	fake.updateCompanyReturns = struct {
		result1 *rbacrpc.Company
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) UpdateCompanyReturnsOnCall(i int, result1 *rbacrpc.Company, result2 error) {
	fake.UpdateCompanyStub = nil
	if fake.updateCompanyReturnsOnCall == nil {
		fake.updateCompanyReturnsOnCall = make(map[int]struct {
			result1 *rbacrpc.Company
			result2 error
		})
	}
	fake.updateCompanyReturnsOnCall[i] = struct {
		result1 *rbacrpc.Company
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) DeleteCompany(ctx context.Context, params *rbacrpc.DeleteCompanyRequest) error {
	fake.deleteCompanyMutex.Lock()
	ret, specificReturn := fake.deleteCompanyReturnsOnCall[len(fake.deleteCompanyArgsForCall)]
	fake.deleteCompanyArgsForCall = append(fake.deleteCompanyArgsForCall, struct {
		ctx    context.Context
		params *rbacrpc.DeleteCompanyRequest
	}{ctx, params})
	fake.recordInvocation("DeleteCompany", []interface{}{ctx, params})
	fake.deleteCompanyMutex.Unlock()
	if fake.DeleteCompanyStub != nil {
		return fake.DeleteCompanyStub(ctx, params)
	}
	if specificReturn {
		return ret.result1
	}
	return fake.deleteCompanyReturns.result1
}

func (fake *FakeCBackender) DeleteCompanyCallCount() int {
	fake.deleteCompanyMutex.RLock()
	defer fake.deleteCompanyMutex.RUnlock()
	return len(fake.deleteCompanyArgsForCall)
}

func (fake *FakeCBackender) DeleteCompanyArgsForCall(i int) (context.Context, *rbacrpc.DeleteCompanyRequest) {
	fake.deleteCompanyMutex.RLock()
	defer fake.deleteCompanyMutex.RUnlock()
	return fake.deleteCompanyArgsForCall[i].ctx, fake.deleteCompanyArgsForCall[i].params
}

func (fake *FakeCBackender) DeleteCompanyReturns(result1 error) {
	fake.DeleteCompanyStub = nil
	fake.deleteCompanyReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeCBackender) DeleteCompanyReturnsOnCall(i int, result1 error) {
	fake.DeleteCompanyStub = nil
	if fake.deleteCompanyReturnsOnCall == nil {
		fake.deleteCompanyReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.deleteCompanyReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeCBackender) CompanyExistsWithIdentifier(ctx context.Context, identifier string) (bool, error) {
	fake.companyExistsWithIdentifierMutex.Lock()
	ret, specificReturn := fake.companyExistsWithIdentifierReturnsOnCall[len(fake.companyExistsWithIdentifierArgsForCall)]
	fake.companyExistsWithIdentifierArgsForCall = append(fake.companyExistsWithIdentifierArgsForCall, struct {
		ctx        context.Context
		identifier string
	}{ctx, identifier})
	fake.recordInvocation("CompanyExistsWithIdentifier", []interface{}{ctx, identifier})
	fake.companyExistsWithIdentifierMutex.Unlock()
	if fake.CompanyExistsWithIdentifierStub != nil {
		return fake.CompanyExistsWithIdentifierStub(ctx, identifier)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.companyExistsWithIdentifierReturns.result1, fake.companyExistsWithIdentifierReturns.result2
}

func (fake *FakeCBackender) CompanyExistsWithIdentifierCallCount() int {
	fake.companyExistsWithIdentifierMutex.RLock()
	defer fake.companyExistsWithIdentifierMutex.RUnlock()
	return len(fake.companyExistsWithIdentifierArgsForCall)
}

func (fake *FakeCBackender) CompanyExistsWithIdentifierArgsForCall(i int) (context.Context, string) {
	fake.companyExistsWithIdentifierMutex.RLock()
	defer fake.companyExistsWithIdentifierMutex.RUnlock()
	return fake.companyExistsWithIdentifierArgsForCall[i].ctx, fake.companyExistsWithIdentifierArgsForCall[i].identifier
}

func (fake *FakeCBackender) CompanyExistsWithIdentifierReturns(result1 bool, result2 error) {
	fake.CompanyExistsWithIdentifierStub = nil
	fake.companyExistsWithIdentifierReturns = struct {
		result1 bool
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) CompanyExistsWithIdentifierReturnsOnCall(i int, result1 bool, result2 error) {
	fake.CompanyExistsWithIdentifierStub = nil
	if fake.companyExistsWithIdentifierReturnsOnCall == nil {
		fake.companyExistsWithIdentifierReturnsOnCall = make(map[int]struct {
			result1 bool
			result2 error
		})
	}
	fake.companyExistsWithIdentifierReturnsOnCall[i] = struct {
		result1 bool
		result2 error
	}{result1, result2}
}

func (fake *FakeCBackender) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.findCompaniesMutex.RLock()
	defer fake.findCompaniesMutex.RUnlock()
	fake.searchCompaniesMutex.RLock()
	defer fake.searchCompaniesMutex.RUnlock()
	fake.selectCompaniesMutex.RLock()
	defer fake.selectCompaniesMutex.RUnlock()
	fake.selectCompanyMutex.RLock()
	defer fake.selectCompanyMutex.RUnlock()
	fake.selectCompanyByCompanyNameMutex.RLock()
	defer fake.selectCompanyByCompanyNameMutex.RUnlock()
	fake.insertCompanyMutex.RLock()
	defer fake.insertCompanyMutex.RUnlock()
	fake.updateCompanyMutex.RLock()
	defer fake.updateCompanyMutex.RUnlock()
	fake.deleteCompanyMutex.RLock()
	defer fake.deleteCompanyMutex.RUnlock()
	fake.companyExistsWithIdentifierMutex.RLock()
	defer fake.companyExistsWithIdentifierMutex.RUnlock()
	return fake.invocations
}

func (fake *FakeCBackender) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ companies.CBackender = new(FakeCBackender)
