// Code generated by counterfeiter. DO NOT EDIT.
package companyresourcesfakes

import (
	"context"
	"sync"

	"code.justin.tv/devrel/devsite-rbac/backend/companyresources"
	"code.justin.tv/devrel/devsite-rbac/rpc/rbacrpc"
)

type FakeCRBackender struct {
	InsertResourceStub        func(ctx context.Context, params *companyresources.ResourceType) error
	insertResourceMutex       sync.RWMutex
	insertResourceArgsForCall []struct {
		ctx    context.Context
		params *companyresources.ResourceType
	}
	insertResourceReturns struct {
		result1 error
	}
	insertResourceReturnsOnCall map[int]struct {
		result1 error
	}
	DeleteResourceStub        func(ctx context.Context, params *companyresources.ResourceType) error
	deleteResourceMutex       sync.RWMutex
	deleteResourceArgsForCall []struct {
		ctx    context.Context
		params *companyresources.ResourceType
	}
	deleteResourceReturns struct {
		result1 error
	}
	deleteResourceReturnsOnCall map[int]struct {
		result1 error
	}
	DeleteResourcesByCompanyStub        func(ctx context.Context, companyID string) error
	deleteResourcesByCompanyMutex       sync.RWMutex
	deleteResourcesByCompanyArgsForCall []struct {
		ctx       context.Context
		companyID string
	}
	deleteResourcesByCompanyReturns struct {
		result1 error
	}
	deleteResourcesByCompanyReturnsOnCall map[int]struct {
		result1 error
	}
	FindResourcesStub        func(ctx context.Context, companyID, resourceType, resourceID string, limit, offset uint64) ([]companyresources.ResourceType, int, error)
	findResourcesMutex       sync.RWMutex
	findResourcesArgsForCall []struct {
		ctx          context.Context
		companyID    string
		resourceType string
		resourceID   string
		limit        uint64
		offset       uint64
	}
	findResourcesReturns struct {
		result1 []companyresources.ResourceType
		result2 int
		result3 error
	}
	findResourcesReturnsOnCall map[int]struct {
		result1 []companyresources.ResourceType
		result2 int
		result3 error
	}
	FindCompaniesWithResourceStub        func(ctx context.Context, externalID, resourceType string) ([]*rbacrpc.Company, error)
	findCompaniesWithResourceMutex       sync.RWMutex
	findCompaniesWithResourceArgsForCall []struct {
		ctx          context.Context
		externalID   string
		resourceType string
	}
	findCompaniesWithResourceReturns struct {
		result1 []*rbacrpc.Company
		result2 error
	}
	findCompaniesWithResourceReturnsOnCall map[int]struct {
		result1 []*rbacrpc.Company
		result2 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeCRBackender) InsertResource(ctx context.Context, params *companyresources.ResourceType) error {
	fake.insertResourceMutex.Lock()
	ret, specificReturn := fake.insertResourceReturnsOnCall[len(fake.insertResourceArgsForCall)]
	fake.insertResourceArgsForCall = append(fake.insertResourceArgsForCall, struct {
		ctx    context.Context
		params *companyresources.ResourceType
	}{ctx, params})
	fake.recordInvocation("InsertResource", []interface{}{ctx, params})
	fake.insertResourceMutex.Unlock()
	if fake.InsertResourceStub != nil {
		return fake.InsertResourceStub(ctx, params)
	}
	if specificReturn {
		return ret.result1
	}
	return fake.insertResourceReturns.result1
}

func (fake *FakeCRBackender) InsertResourceCallCount() int {
	fake.insertResourceMutex.RLock()
	defer fake.insertResourceMutex.RUnlock()
	return len(fake.insertResourceArgsForCall)
}

func (fake *FakeCRBackender) InsertResourceArgsForCall(i int) (context.Context, *companyresources.ResourceType) {
	fake.insertResourceMutex.RLock()
	defer fake.insertResourceMutex.RUnlock()
	return fake.insertResourceArgsForCall[i].ctx, fake.insertResourceArgsForCall[i].params
}

func (fake *FakeCRBackender) InsertResourceReturns(result1 error) {
	fake.InsertResourceStub = nil
	fake.insertResourceReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeCRBackender) InsertResourceReturnsOnCall(i int, result1 error) {
	fake.InsertResourceStub = nil
	if fake.insertResourceReturnsOnCall == nil {
		fake.insertResourceReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.insertResourceReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeCRBackender) DeleteResource(ctx context.Context, params *companyresources.ResourceType) error {
	fake.deleteResourceMutex.Lock()
	ret, specificReturn := fake.deleteResourceReturnsOnCall[len(fake.deleteResourceArgsForCall)]
	fake.deleteResourceArgsForCall = append(fake.deleteResourceArgsForCall, struct {
		ctx    context.Context
		params *companyresources.ResourceType
	}{ctx, params})
	fake.recordInvocation("DeleteResource", []interface{}{ctx, params})
	fake.deleteResourceMutex.Unlock()
	if fake.DeleteResourceStub != nil {
		return fake.DeleteResourceStub(ctx, params)
	}
	if specificReturn {
		return ret.result1
	}
	return fake.deleteResourceReturns.result1
}

func (fake *FakeCRBackender) DeleteResourceCallCount() int {
	fake.deleteResourceMutex.RLock()
	defer fake.deleteResourceMutex.RUnlock()
	return len(fake.deleteResourceArgsForCall)
}

func (fake *FakeCRBackender) DeleteResourceArgsForCall(i int) (context.Context, *companyresources.ResourceType) {
	fake.deleteResourceMutex.RLock()
	defer fake.deleteResourceMutex.RUnlock()
	return fake.deleteResourceArgsForCall[i].ctx, fake.deleteResourceArgsForCall[i].params
}

func (fake *FakeCRBackender) DeleteResourceReturns(result1 error) {
	fake.DeleteResourceStub = nil
	fake.deleteResourceReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeCRBackender) DeleteResourceReturnsOnCall(i int, result1 error) {
	fake.DeleteResourceStub = nil
	if fake.deleteResourceReturnsOnCall == nil {
		fake.deleteResourceReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.deleteResourceReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeCRBackender) DeleteResourcesByCompany(ctx context.Context, companyID string) error {
	fake.deleteResourcesByCompanyMutex.Lock()
	ret, specificReturn := fake.deleteResourcesByCompanyReturnsOnCall[len(fake.deleteResourcesByCompanyArgsForCall)]
	fake.deleteResourcesByCompanyArgsForCall = append(fake.deleteResourcesByCompanyArgsForCall, struct {
		ctx       context.Context
		companyID string
	}{ctx, companyID})
	fake.recordInvocation("DeleteResourcesByCompany", []interface{}{ctx, companyID})
	fake.deleteResourcesByCompanyMutex.Unlock()
	if fake.DeleteResourcesByCompanyStub != nil {
		return fake.DeleteResourcesByCompanyStub(ctx, companyID)
	}
	if specificReturn {
		return ret.result1
	}
	return fake.deleteResourcesByCompanyReturns.result1
}

func (fake *FakeCRBackender) DeleteResourcesByCompanyCallCount() int {
	fake.deleteResourcesByCompanyMutex.RLock()
	defer fake.deleteResourcesByCompanyMutex.RUnlock()
	return len(fake.deleteResourcesByCompanyArgsForCall)
}

func (fake *FakeCRBackender) DeleteResourcesByCompanyArgsForCall(i int) (context.Context, string) {
	fake.deleteResourcesByCompanyMutex.RLock()
	defer fake.deleteResourcesByCompanyMutex.RUnlock()
	return fake.deleteResourcesByCompanyArgsForCall[i].ctx, fake.deleteResourcesByCompanyArgsForCall[i].companyID
}

func (fake *FakeCRBackender) DeleteResourcesByCompanyReturns(result1 error) {
	fake.DeleteResourcesByCompanyStub = nil
	fake.deleteResourcesByCompanyReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeCRBackender) DeleteResourcesByCompanyReturnsOnCall(i int, result1 error) {
	fake.DeleteResourcesByCompanyStub = nil
	if fake.deleteResourcesByCompanyReturnsOnCall == nil {
		fake.deleteResourcesByCompanyReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.deleteResourcesByCompanyReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeCRBackender) FindResources(ctx context.Context, companyID string, resourceType string, resourceID string, limit uint64, offset uint64) ([]companyresources.ResourceType, int, error) {
	fake.findResourcesMutex.Lock()
	ret, specificReturn := fake.findResourcesReturnsOnCall[len(fake.findResourcesArgsForCall)]
	fake.findResourcesArgsForCall = append(fake.findResourcesArgsForCall, struct {
		ctx          context.Context
		companyID    string
		resourceType string
		resourceID   string
		limit        uint64
		offset       uint64
	}{ctx, companyID, resourceType, resourceID, limit, offset})
	fake.recordInvocation("FindResources", []interface{}{ctx, companyID, resourceType, resourceID, limit, offset})
	fake.findResourcesMutex.Unlock()
	if fake.FindResourcesStub != nil {
		return fake.FindResourcesStub(ctx, companyID, resourceType, resourceID, limit, offset)
	}
	if specificReturn {
		return ret.result1, ret.result2, ret.result3
	}
	return fake.findResourcesReturns.result1, fake.findResourcesReturns.result2, fake.findResourcesReturns.result3
}

func (fake *FakeCRBackender) FindResourcesCallCount() int {
	fake.findResourcesMutex.RLock()
	defer fake.findResourcesMutex.RUnlock()
	return len(fake.findResourcesArgsForCall)
}

func (fake *FakeCRBackender) FindResourcesArgsForCall(i int) (context.Context, string, string, string, uint64, uint64) {
	fake.findResourcesMutex.RLock()
	defer fake.findResourcesMutex.RUnlock()
	return fake.findResourcesArgsForCall[i].ctx, fake.findResourcesArgsForCall[i].companyID, fake.findResourcesArgsForCall[i].resourceType, fake.findResourcesArgsForCall[i].resourceID, fake.findResourcesArgsForCall[i].limit, fake.findResourcesArgsForCall[i].offset
}

func (fake *FakeCRBackender) FindResourcesReturns(result1 []companyresources.ResourceType, result2 int, result3 error) {
	fake.FindResourcesStub = nil
	fake.findResourcesReturns = struct {
		result1 []companyresources.ResourceType
		result2 int
		result3 error
	}{result1, result2, result3}
}

func (fake *FakeCRBackender) FindResourcesReturnsOnCall(i int, result1 []companyresources.ResourceType, result2 int, result3 error) {
	fake.FindResourcesStub = nil
	if fake.findResourcesReturnsOnCall == nil {
		fake.findResourcesReturnsOnCall = make(map[int]struct {
			result1 []companyresources.ResourceType
			result2 int
			result3 error
		})
	}
	fake.findResourcesReturnsOnCall[i] = struct {
		result1 []companyresources.ResourceType
		result2 int
		result3 error
	}{result1, result2, result3}
}

func (fake *FakeCRBackender) FindCompaniesWithResource(ctx context.Context, externalID string, resourceType string) ([]*rbacrpc.Company, error) {
	fake.findCompaniesWithResourceMutex.Lock()
	ret, specificReturn := fake.findCompaniesWithResourceReturnsOnCall[len(fake.findCompaniesWithResourceArgsForCall)]
	fake.findCompaniesWithResourceArgsForCall = append(fake.findCompaniesWithResourceArgsForCall, struct {
		ctx          context.Context
		externalID   string
		resourceType string
	}{ctx, externalID, resourceType})
	fake.recordInvocation("FindCompaniesWithResource", []interface{}{ctx, externalID, resourceType})
	fake.findCompaniesWithResourceMutex.Unlock()
	if fake.FindCompaniesWithResourceStub != nil {
		return fake.FindCompaniesWithResourceStub(ctx, externalID, resourceType)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.findCompaniesWithResourceReturns.result1, fake.findCompaniesWithResourceReturns.result2
}

func (fake *FakeCRBackender) FindCompaniesWithResourceCallCount() int {
	fake.findCompaniesWithResourceMutex.RLock()
	defer fake.findCompaniesWithResourceMutex.RUnlock()
	return len(fake.findCompaniesWithResourceArgsForCall)
}

func (fake *FakeCRBackender) FindCompaniesWithResourceArgsForCall(i int) (context.Context, string, string) {
	fake.findCompaniesWithResourceMutex.RLock()
	defer fake.findCompaniesWithResourceMutex.RUnlock()
	return fake.findCompaniesWithResourceArgsForCall[i].ctx, fake.findCompaniesWithResourceArgsForCall[i].externalID, fake.findCompaniesWithResourceArgsForCall[i].resourceType
}

func (fake *FakeCRBackender) FindCompaniesWithResourceReturns(result1 []*rbacrpc.Company, result2 error) {
	fake.FindCompaniesWithResourceStub = nil
	fake.findCompaniesWithResourceReturns = struct {
		result1 []*rbacrpc.Company
		result2 error
	}{result1, result2}
}

func (fake *FakeCRBackender) FindCompaniesWithResourceReturnsOnCall(i int, result1 []*rbacrpc.Company, result2 error) {
	fake.FindCompaniesWithResourceStub = nil
	if fake.findCompaniesWithResourceReturnsOnCall == nil {
		fake.findCompaniesWithResourceReturnsOnCall = make(map[int]struct {
			result1 []*rbacrpc.Company
			result2 error
		})
	}
	fake.findCompaniesWithResourceReturnsOnCall[i] = struct {
		result1 []*rbacrpc.Company
		result2 error
	}{result1, result2}
}

func (fake *FakeCRBackender) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.insertResourceMutex.RLock()
	defer fake.insertResourceMutex.RUnlock()
	fake.deleteResourceMutex.RLock()
	defer fake.deleteResourceMutex.RUnlock()
	fake.deleteResourcesByCompanyMutex.RLock()
	defer fake.deleteResourcesByCompanyMutex.RUnlock()
	fake.findResourcesMutex.RLock()
	defer fake.findResourcesMutex.RUnlock()
	fake.findCompaniesWithResourceMutex.RLock()
	defer fake.findCompaniesWithResourceMutex.RUnlock()
	return fake.invocations
}

func (fake *FakeCRBackender) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ companyresources.CRBackender = new(FakeCRBackender)
