// Code generated by errxer. DO NOT EDIT.
package companyresources

import (
	"context"
	"time"

	"code.justin.tv/chat/golibs/errx"
	"code.justin.tv/devrel/devsite-rbac/rpc/rbacrpc"
)

type CRBackenderErrx struct {
	CRBackender CRBackender
	TimingFunc  func(ctx context.Context, d time.Duration, method string, err error)
}

// InsertResource wraps CRBackender errors with errx
func (e *CRBackenderErrx) InsertResource(ctx context.Context, params *ResourceType) error {
	start := time.Now()
	err := e.CRBackender.InsertResource(ctx, params)
	if e.TimingFunc != nil {
		e.TimingFunc(ctx, time.Since(start), "InsertResource", err)
	}
	return errx.NewWithSkip(err, 1)
}

// DeleteResource wraps CRBackender errors with errx
func (e *CRBackenderErrx) DeleteResource(ctx context.Context, params *ResourceType) error {
	start := time.Now()
	err := e.CRBackender.DeleteResource(ctx, params)
	if e.TimingFunc != nil {
		e.TimingFunc(ctx, time.Since(start), "DeleteResource", err)
	}
	return errx.NewWithSkip(err, 1)
}

// DeleteResourcesByCompany wraps CRBackender errors with errx
func (e *CRBackenderErrx) DeleteResourcesByCompany(ctx context.Context, companyID string) error {
	start := time.Now()
	err := e.CRBackender.DeleteResourcesByCompany(ctx, companyID)
	if e.TimingFunc != nil {
		e.TimingFunc(ctx, time.Since(start), "DeleteResourcesByCompany", err)
	}
	return errx.NewWithSkip(err, 1)
}

// FindResources wraps CRBackender errors with errx
func (e *CRBackenderErrx) FindResources(ctx context.Context, companyID string, resourceType string, resourceID string, limit uint64, offset uint64) ([]ResourceType, int, error) {
	start := time.Now()
	r0, r1, err := e.CRBackender.FindResources(ctx, companyID, resourceType, resourceID, limit, offset)
	if e.TimingFunc != nil {
		e.TimingFunc(ctx, time.Since(start), "FindResources", err)
	}
	return r0, r1, errx.NewWithSkip(err, 1)
}

// FindCompaniesWithResource wraps CRBackender errors with errx
func (e *CRBackenderErrx) FindCompaniesWithResource(ctx context.Context, externalID string, resourceType string) ([]*rbacrpc.Company, error) {
	start := time.Now()
	r0, err := e.CRBackender.FindCompaniesWithResource(ctx, externalID, resourceType)
	if e.TimingFunc != nil {
		e.TimingFunc(ctx, time.Since(start), "FindCompaniesWithResource", err)
	}
	return r0, errx.NewWithSkip(err, 1)
}
