// Code generated by errxer. DO NOT EDIT.
package memberships

import (
	"context"
	"time"

	"code.justin.tv/chat/golibs/errx"
)

type MembershipsErrx struct {
	Memberships Memberships
	TimingFunc  func(ctx context.Context, d time.Duration, method string, err error)
}

// GetMembership wraps Memberships errors with errx
func (e *MembershipsErrx) GetMembership(ctx context.Context, companyID string, twitchID string) (Membership, error) {
	start := time.Now()
	r0, err := e.Memberships.GetMembership(ctx, companyID, twitchID)
	if e.TimingFunc != nil {
		e.TimingFunc(ctx, time.Since(start), "GetMembership", err)
	}
	return r0, errx.NewWithSkip(err, 1)
}

// ListMemberships wraps Memberships errors with errx
func (e *MembershipsErrx) ListMemberships(ctx context.Context, params ListMembershipsParams) ([]Membership, int32, error) {
	start := time.Now()
	r0, r1, err := e.Memberships.ListMemberships(ctx, params)
	if e.TimingFunc != nil {
		e.TimingFunc(ctx, time.Since(start), "ListMemberships", err)
	}
	return r0, r1, errx.NewWithSkip(err, 1)
}

// InsertMembership wraps Memberships errors with errx
func (e *MembershipsErrx) InsertMembership(ctx context.Context, m *Membership) error {
	start := time.Now()
	err := e.Memberships.InsertMembership(ctx, m)
	if e.TimingFunc != nil {
		e.TimingFunc(ctx, time.Since(start), "InsertMembership", err)
	}
	return errx.NewWithSkip(err, 1)
}

// UpdateMembership wraps Memberships errors with errx
func (e *MembershipsErrx) UpdateMembership(ctx context.Context, m *Membership) error {
	start := time.Now()
	err := e.Memberships.UpdateMembership(ctx, m)
	if e.TimingFunc != nil {
		e.TimingFunc(ctx, time.Since(start), "UpdateMembership", err)
	}
	return errx.NewWithSkip(err, 1)
}

// DeleteMembership wraps Memberships errors with errx
func (e *MembershipsErrx) DeleteMembership(ctx context.Context, companyID string, twitchID string) error {
	start := time.Now()
	err := e.Memberships.DeleteMembership(ctx, companyID, twitchID)
	if e.TimingFunc != nil {
		e.TimingFunc(ctx, time.Since(start), "DeleteMembership", err)
	}
	return errx.NewWithSkip(err, 1)
}

// GetAdminsByCompany wraps Memberships errors with errx
func (e *MembershipsErrx) GetAdminsByCompany(ctx context.Context, companyID string) ([]Membership, error) {
	start := time.Now()
	r0, err := e.Memberships.GetAdminsByCompany(ctx, companyID)
	if e.TimingFunc != nil {
		e.TimingFunc(ctx, time.Since(start), "GetAdminsByCompany", err)
	}
	return r0, errx.NewWithSkip(err, 1)
}

// GetMembershipsByAccount wraps Memberships errors with errx
func (e *MembershipsErrx) GetMembershipsByAccount(ctx context.Context, twitchID string) ([]Membership, error) {
	start := time.Now()
	r0, err := e.Memberships.GetMembershipsByAccount(ctx, twitchID)
	if e.TimingFunc != nil {
		e.TimingFunc(ctx, time.Since(start), "GetMembershipsByAccount", err)
	}
	return r0, errx.NewWithSkip(err, 1)
}

// MigrateOwner wraps Memberships errors with errx
func (e *MembershipsErrx) MigrateOwner(ctx context.Context, companyID string, oldOwnerID string, newOwnerID string) error {
	start := time.Now()
	err := e.Memberships.MigrateOwner(ctx, companyID, oldOwnerID, newOwnerID)
	if e.TimingFunc != nil {
		e.TimingFunc(ctx, time.Since(start), "MigrateOwner", err)
	}
	return errx.NewWithSkip(err, 1)
}

// DeleteCompanyMemberships wraps Memberships errors with errx
func (e *MembershipsErrx) DeleteCompanyMemberships(ctx context.Context, companyID string) error {
	start := time.Now()
	err := e.Memberships.DeleteCompanyMemberships(ctx, companyID)
	if e.TimingFunc != nil {
		e.TimingFunc(ctx, time.Since(start), "DeleteCompanyMemberships", err)
	}
	return errx.NewWithSkip(err, 1)
}
