// Code generated by counterfeiter. DO NOT EDIT.
package membershipsfakes

import (
	"context"
	"sync"

	"code.justin.tv/devrel/devsite-rbac/backend/memberships"
)

type FakeMemberships struct {
	GetMembershipStub        func(ctx context.Context, companyID, twitchID string) (memberships.Membership, error)
	getMembershipMutex       sync.RWMutex
	getMembershipArgsForCall []struct {
		ctx       context.Context
		companyID string
		twitchID  string
	}
	getMembershipReturns struct {
		result1 memberships.Membership
		result2 error
	}
	getMembershipReturnsOnCall map[int]struct {
		result1 memberships.Membership
		result2 error
	}
	ListMembershipsStub        func(ctx context.Context, params memberships.ListMembershipsParams) ([]memberships.Membership, int32, error)
	listMembershipsMutex       sync.RWMutex
	listMembershipsArgsForCall []struct {
		ctx    context.Context
		params memberships.ListMembershipsParams
	}
	listMembershipsReturns struct {
		result1 []memberships.Membership
		result2 int32
		result3 error
	}
	listMembershipsReturnsOnCall map[int]struct {
		result1 []memberships.Membership
		result2 int32
		result3 error
	}
	InsertMembershipStub        func(ctx context.Context, m *memberships.Membership) error
	insertMembershipMutex       sync.RWMutex
	insertMembershipArgsForCall []struct {
		ctx context.Context
		m   *memberships.Membership
	}
	insertMembershipReturns struct {
		result1 error
	}
	insertMembershipReturnsOnCall map[int]struct {
		result1 error
	}
	UpdateMembershipStub        func(ctx context.Context, m *memberships.Membership) error
	updateMembershipMutex       sync.RWMutex
	updateMembershipArgsForCall []struct {
		ctx context.Context
		m   *memberships.Membership
	}
	updateMembershipReturns struct {
		result1 error
	}
	updateMembershipReturnsOnCall map[int]struct {
		result1 error
	}
	DeleteMembershipStub        func(ctx context.Context, companyID, twitchID string) error
	deleteMembershipMutex       sync.RWMutex
	deleteMembershipArgsForCall []struct {
		ctx       context.Context
		companyID string
		twitchID  string
	}
	deleteMembershipReturns struct {
		result1 error
	}
	deleteMembershipReturnsOnCall map[int]struct {
		result1 error
	}
	GetAdminsByCompanyStub        func(ctx context.Context, companyID string) ([]memberships.Membership, error)
	getAdminsByCompanyMutex       sync.RWMutex
	getAdminsByCompanyArgsForCall []struct {
		ctx       context.Context
		companyID string
	}
	getAdminsByCompanyReturns struct {
		result1 []memberships.Membership
		result2 error
	}
	getAdminsByCompanyReturnsOnCall map[int]struct {
		result1 []memberships.Membership
		result2 error
	}
	GetMembershipsByAccountStub        func(ctx context.Context, twitchID string) ([]memberships.Membership, error)
	getMembershipsByAccountMutex       sync.RWMutex
	getMembershipsByAccountArgsForCall []struct {
		ctx      context.Context
		twitchID string
	}
	getMembershipsByAccountReturns struct {
		result1 []memberships.Membership
		result2 error
	}
	getMembershipsByAccountReturnsOnCall map[int]struct {
		result1 []memberships.Membership
		result2 error
	}
	MigrateOwnerStub        func(ctx context.Context, companyID string, oldOwnerID string, newOwnerID string) error
	migrateOwnerMutex       sync.RWMutex
	migrateOwnerArgsForCall []struct {
		ctx        context.Context
		companyID  string
		oldOwnerID string
		newOwnerID string
	}
	migrateOwnerReturns struct {
		result1 error
	}
	migrateOwnerReturnsOnCall map[int]struct {
		result1 error
	}
	DeleteCompanyMembershipsStub        func(ctx context.Context, companyID string) error
	deleteCompanyMembershipsMutex       sync.RWMutex
	deleteCompanyMembershipsArgsForCall []struct {
		ctx       context.Context
		companyID string
	}
	deleteCompanyMembershipsReturns struct {
		result1 error
	}
	deleteCompanyMembershipsReturnsOnCall map[int]struct {
		result1 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeMemberships) GetMembership(ctx context.Context, companyID string, twitchID string) (memberships.Membership, error) {
	fake.getMembershipMutex.Lock()
	ret, specificReturn := fake.getMembershipReturnsOnCall[len(fake.getMembershipArgsForCall)]
	fake.getMembershipArgsForCall = append(fake.getMembershipArgsForCall, struct {
		ctx       context.Context
		companyID string
		twitchID  string
	}{ctx, companyID, twitchID})
	fake.recordInvocation("GetMembership", []interface{}{ctx, companyID, twitchID})
	fake.getMembershipMutex.Unlock()
	if fake.GetMembershipStub != nil {
		return fake.GetMembershipStub(ctx, companyID, twitchID)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.getMembershipReturns.result1, fake.getMembershipReturns.result2
}

func (fake *FakeMemberships) GetMembershipCallCount() int {
	fake.getMembershipMutex.RLock()
	defer fake.getMembershipMutex.RUnlock()
	return len(fake.getMembershipArgsForCall)
}

func (fake *FakeMemberships) GetMembershipArgsForCall(i int) (context.Context, string, string) {
	fake.getMembershipMutex.RLock()
	defer fake.getMembershipMutex.RUnlock()
	return fake.getMembershipArgsForCall[i].ctx, fake.getMembershipArgsForCall[i].companyID, fake.getMembershipArgsForCall[i].twitchID
}

func (fake *FakeMemberships) GetMembershipReturns(result1 memberships.Membership, result2 error) {
	fake.GetMembershipStub = nil
	fake.getMembershipReturns = struct {
		result1 memberships.Membership
		result2 error
	}{result1, result2}
}

func (fake *FakeMemberships) GetMembershipReturnsOnCall(i int, result1 memberships.Membership, result2 error) {
	fake.GetMembershipStub = nil
	if fake.getMembershipReturnsOnCall == nil {
		fake.getMembershipReturnsOnCall = make(map[int]struct {
			result1 memberships.Membership
			result2 error
		})
	}
	fake.getMembershipReturnsOnCall[i] = struct {
		result1 memberships.Membership
		result2 error
	}{result1, result2}
}

func (fake *FakeMemberships) ListMemberships(ctx context.Context, params memberships.ListMembershipsParams) ([]memberships.Membership, int32, error) {
	fake.listMembershipsMutex.Lock()
	ret, specificReturn := fake.listMembershipsReturnsOnCall[len(fake.listMembershipsArgsForCall)]
	fake.listMembershipsArgsForCall = append(fake.listMembershipsArgsForCall, struct {
		ctx    context.Context
		params memberships.ListMembershipsParams
	}{ctx, params})
	fake.recordInvocation("ListMemberships", []interface{}{ctx, params})
	fake.listMembershipsMutex.Unlock()
	if fake.ListMembershipsStub != nil {
		return fake.ListMembershipsStub(ctx, params)
	}
	if specificReturn {
		return ret.result1, ret.result2, ret.result3
	}
	return fake.listMembershipsReturns.result1, fake.listMembershipsReturns.result2, fake.listMembershipsReturns.result3
}

func (fake *FakeMemberships) ListMembershipsCallCount() int {
	fake.listMembershipsMutex.RLock()
	defer fake.listMembershipsMutex.RUnlock()
	return len(fake.listMembershipsArgsForCall)
}

func (fake *FakeMemberships) ListMembershipsArgsForCall(i int) (context.Context, memberships.ListMembershipsParams) {
	fake.listMembershipsMutex.RLock()
	defer fake.listMembershipsMutex.RUnlock()
	return fake.listMembershipsArgsForCall[i].ctx, fake.listMembershipsArgsForCall[i].params
}

func (fake *FakeMemberships) ListMembershipsReturns(result1 []memberships.Membership, result2 int32, result3 error) {
	fake.ListMembershipsStub = nil
	fake.listMembershipsReturns = struct {
		result1 []memberships.Membership
		result2 int32
		result3 error
	}{result1, result2, result3}
}

func (fake *FakeMemberships) ListMembershipsReturnsOnCall(i int, result1 []memberships.Membership, result2 int32, result3 error) {
	fake.ListMembershipsStub = nil
	if fake.listMembershipsReturnsOnCall == nil {
		fake.listMembershipsReturnsOnCall = make(map[int]struct {
			result1 []memberships.Membership
			result2 int32
			result3 error
		})
	}
	fake.listMembershipsReturnsOnCall[i] = struct {
		result1 []memberships.Membership
		result2 int32
		result3 error
	}{result1, result2, result3}
}

func (fake *FakeMemberships) InsertMembership(ctx context.Context, m *memberships.Membership) error {
	fake.insertMembershipMutex.Lock()
	ret, specificReturn := fake.insertMembershipReturnsOnCall[len(fake.insertMembershipArgsForCall)]
	fake.insertMembershipArgsForCall = append(fake.insertMembershipArgsForCall, struct {
		ctx context.Context
		m   *memberships.Membership
	}{ctx, m})
	fake.recordInvocation("InsertMembership", []interface{}{ctx, m})
	fake.insertMembershipMutex.Unlock()
	if fake.InsertMembershipStub != nil {
		return fake.InsertMembershipStub(ctx, m)
	}
	if specificReturn {
		return ret.result1
	}
	return fake.insertMembershipReturns.result1
}

func (fake *FakeMemberships) InsertMembershipCallCount() int {
	fake.insertMembershipMutex.RLock()
	defer fake.insertMembershipMutex.RUnlock()
	return len(fake.insertMembershipArgsForCall)
}

func (fake *FakeMemberships) InsertMembershipArgsForCall(i int) (context.Context, *memberships.Membership) {
	fake.insertMembershipMutex.RLock()
	defer fake.insertMembershipMutex.RUnlock()
	return fake.insertMembershipArgsForCall[i].ctx, fake.insertMembershipArgsForCall[i].m
}

func (fake *FakeMemberships) InsertMembershipReturns(result1 error) {
	fake.InsertMembershipStub = nil
	fake.insertMembershipReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeMemberships) InsertMembershipReturnsOnCall(i int, result1 error) {
	fake.InsertMembershipStub = nil
	if fake.insertMembershipReturnsOnCall == nil {
		fake.insertMembershipReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.insertMembershipReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeMemberships) UpdateMembership(ctx context.Context, m *memberships.Membership) error {
	fake.updateMembershipMutex.Lock()
	ret, specificReturn := fake.updateMembershipReturnsOnCall[len(fake.updateMembershipArgsForCall)]
	fake.updateMembershipArgsForCall = append(fake.updateMembershipArgsForCall, struct {
		ctx context.Context
		m   *memberships.Membership
	}{ctx, m})
	fake.recordInvocation("UpdateMembership", []interface{}{ctx, m})
	fake.updateMembershipMutex.Unlock()
	if fake.UpdateMembershipStub != nil {
		return fake.UpdateMembershipStub(ctx, m)
	}
	if specificReturn {
		return ret.result1
	}
	return fake.updateMembershipReturns.result1
}

func (fake *FakeMemberships) UpdateMembershipCallCount() int {
	fake.updateMembershipMutex.RLock()
	defer fake.updateMembershipMutex.RUnlock()
	return len(fake.updateMembershipArgsForCall)
}

func (fake *FakeMemberships) UpdateMembershipArgsForCall(i int) (context.Context, *memberships.Membership) {
	fake.updateMembershipMutex.RLock()
	defer fake.updateMembershipMutex.RUnlock()
	return fake.updateMembershipArgsForCall[i].ctx, fake.updateMembershipArgsForCall[i].m
}

func (fake *FakeMemberships) UpdateMembershipReturns(result1 error) {
	fake.UpdateMembershipStub = nil
	fake.updateMembershipReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeMemberships) UpdateMembershipReturnsOnCall(i int, result1 error) {
	fake.UpdateMembershipStub = nil
	if fake.updateMembershipReturnsOnCall == nil {
		fake.updateMembershipReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.updateMembershipReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeMemberships) DeleteMembership(ctx context.Context, companyID string, twitchID string) error {
	fake.deleteMembershipMutex.Lock()
	ret, specificReturn := fake.deleteMembershipReturnsOnCall[len(fake.deleteMembershipArgsForCall)]
	fake.deleteMembershipArgsForCall = append(fake.deleteMembershipArgsForCall, struct {
		ctx       context.Context
		companyID string
		twitchID  string
	}{ctx, companyID, twitchID})
	fake.recordInvocation("DeleteMembership", []interface{}{ctx, companyID, twitchID})
	fake.deleteMembershipMutex.Unlock()
	if fake.DeleteMembershipStub != nil {
		return fake.DeleteMembershipStub(ctx, companyID, twitchID)
	}
	if specificReturn {
		return ret.result1
	}
	return fake.deleteMembershipReturns.result1
}

func (fake *FakeMemberships) DeleteMembershipCallCount() int {
	fake.deleteMembershipMutex.RLock()
	defer fake.deleteMembershipMutex.RUnlock()
	return len(fake.deleteMembershipArgsForCall)
}

func (fake *FakeMemberships) DeleteMembershipArgsForCall(i int) (context.Context, string, string) {
	fake.deleteMembershipMutex.RLock()
	defer fake.deleteMembershipMutex.RUnlock()
	return fake.deleteMembershipArgsForCall[i].ctx, fake.deleteMembershipArgsForCall[i].companyID, fake.deleteMembershipArgsForCall[i].twitchID
}

func (fake *FakeMemberships) DeleteMembershipReturns(result1 error) {
	fake.DeleteMembershipStub = nil
	fake.deleteMembershipReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeMemberships) DeleteMembershipReturnsOnCall(i int, result1 error) {
	fake.DeleteMembershipStub = nil
	if fake.deleteMembershipReturnsOnCall == nil {
		fake.deleteMembershipReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.deleteMembershipReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeMemberships) GetAdminsByCompany(ctx context.Context, companyID string) ([]memberships.Membership, error) {
	fake.getAdminsByCompanyMutex.Lock()
	ret, specificReturn := fake.getAdminsByCompanyReturnsOnCall[len(fake.getAdminsByCompanyArgsForCall)]
	fake.getAdminsByCompanyArgsForCall = append(fake.getAdminsByCompanyArgsForCall, struct {
		ctx       context.Context
		companyID string
	}{ctx, companyID})
	fake.recordInvocation("GetAdminsByCompany", []interface{}{ctx, companyID})
	fake.getAdminsByCompanyMutex.Unlock()
	if fake.GetAdminsByCompanyStub != nil {
		return fake.GetAdminsByCompanyStub(ctx, companyID)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.getAdminsByCompanyReturns.result1, fake.getAdminsByCompanyReturns.result2
}

func (fake *FakeMemberships) GetAdminsByCompanyCallCount() int {
	fake.getAdminsByCompanyMutex.RLock()
	defer fake.getAdminsByCompanyMutex.RUnlock()
	return len(fake.getAdminsByCompanyArgsForCall)
}

func (fake *FakeMemberships) GetAdminsByCompanyArgsForCall(i int) (context.Context, string) {
	fake.getAdminsByCompanyMutex.RLock()
	defer fake.getAdminsByCompanyMutex.RUnlock()
	return fake.getAdminsByCompanyArgsForCall[i].ctx, fake.getAdminsByCompanyArgsForCall[i].companyID
}

func (fake *FakeMemberships) GetAdminsByCompanyReturns(result1 []memberships.Membership, result2 error) {
	fake.GetAdminsByCompanyStub = nil
	fake.getAdminsByCompanyReturns = struct {
		result1 []memberships.Membership
		result2 error
	}{result1, result2}
}

func (fake *FakeMemberships) GetAdminsByCompanyReturnsOnCall(i int, result1 []memberships.Membership, result2 error) {
	fake.GetAdminsByCompanyStub = nil
	if fake.getAdminsByCompanyReturnsOnCall == nil {
		fake.getAdminsByCompanyReturnsOnCall = make(map[int]struct {
			result1 []memberships.Membership
			result2 error
		})
	}
	fake.getAdminsByCompanyReturnsOnCall[i] = struct {
		result1 []memberships.Membership
		result2 error
	}{result1, result2}
}

func (fake *FakeMemberships) GetMembershipsByAccount(ctx context.Context, twitchID string) ([]memberships.Membership, error) {
	fake.getMembershipsByAccountMutex.Lock()
	ret, specificReturn := fake.getMembershipsByAccountReturnsOnCall[len(fake.getMembershipsByAccountArgsForCall)]
	fake.getMembershipsByAccountArgsForCall = append(fake.getMembershipsByAccountArgsForCall, struct {
		ctx      context.Context
		twitchID string
	}{ctx, twitchID})
	fake.recordInvocation("GetMembershipsByAccount", []interface{}{ctx, twitchID})
	fake.getMembershipsByAccountMutex.Unlock()
	if fake.GetMembershipsByAccountStub != nil {
		return fake.GetMembershipsByAccountStub(ctx, twitchID)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.getMembershipsByAccountReturns.result1, fake.getMembershipsByAccountReturns.result2
}

func (fake *FakeMemberships) GetMembershipsByAccountCallCount() int {
	fake.getMembershipsByAccountMutex.RLock()
	defer fake.getMembershipsByAccountMutex.RUnlock()
	return len(fake.getMembershipsByAccountArgsForCall)
}

func (fake *FakeMemberships) GetMembershipsByAccountArgsForCall(i int) (context.Context, string) {
	fake.getMembershipsByAccountMutex.RLock()
	defer fake.getMembershipsByAccountMutex.RUnlock()
	return fake.getMembershipsByAccountArgsForCall[i].ctx, fake.getMembershipsByAccountArgsForCall[i].twitchID
}

func (fake *FakeMemberships) GetMembershipsByAccountReturns(result1 []memberships.Membership, result2 error) {
	fake.GetMembershipsByAccountStub = nil
	fake.getMembershipsByAccountReturns = struct {
		result1 []memberships.Membership
		result2 error
	}{result1, result2}
}

func (fake *FakeMemberships) GetMembershipsByAccountReturnsOnCall(i int, result1 []memberships.Membership, result2 error) {
	fake.GetMembershipsByAccountStub = nil
	if fake.getMembershipsByAccountReturnsOnCall == nil {
		fake.getMembershipsByAccountReturnsOnCall = make(map[int]struct {
			result1 []memberships.Membership
			result2 error
		})
	}
	fake.getMembershipsByAccountReturnsOnCall[i] = struct {
		result1 []memberships.Membership
		result2 error
	}{result1, result2}
}

func (fake *FakeMemberships) MigrateOwner(ctx context.Context, companyID string, oldOwnerID string, newOwnerID string) error {
	fake.migrateOwnerMutex.Lock()
	ret, specificReturn := fake.migrateOwnerReturnsOnCall[len(fake.migrateOwnerArgsForCall)]
	fake.migrateOwnerArgsForCall = append(fake.migrateOwnerArgsForCall, struct {
		ctx        context.Context
		companyID  string
		oldOwnerID string
		newOwnerID string
	}{ctx, companyID, oldOwnerID, newOwnerID})
	fake.recordInvocation("MigrateOwner", []interface{}{ctx, companyID, oldOwnerID, newOwnerID})
	fake.migrateOwnerMutex.Unlock()
	if fake.MigrateOwnerStub != nil {
		return fake.MigrateOwnerStub(ctx, companyID, oldOwnerID, newOwnerID)
	}
	if specificReturn {
		return ret.result1
	}
	return fake.migrateOwnerReturns.result1
}

func (fake *FakeMemberships) MigrateOwnerCallCount() int {
	fake.migrateOwnerMutex.RLock()
	defer fake.migrateOwnerMutex.RUnlock()
	return len(fake.migrateOwnerArgsForCall)
}

func (fake *FakeMemberships) MigrateOwnerArgsForCall(i int) (context.Context, string, string, string) {
	fake.migrateOwnerMutex.RLock()
	defer fake.migrateOwnerMutex.RUnlock()
	return fake.migrateOwnerArgsForCall[i].ctx, fake.migrateOwnerArgsForCall[i].companyID, fake.migrateOwnerArgsForCall[i].oldOwnerID, fake.migrateOwnerArgsForCall[i].newOwnerID
}

func (fake *FakeMemberships) MigrateOwnerReturns(result1 error) {
	fake.MigrateOwnerStub = nil
	fake.migrateOwnerReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeMemberships) MigrateOwnerReturnsOnCall(i int, result1 error) {
	fake.MigrateOwnerStub = nil
	if fake.migrateOwnerReturnsOnCall == nil {
		fake.migrateOwnerReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.migrateOwnerReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeMemberships) DeleteCompanyMemberships(ctx context.Context, companyID string) error {
	fake.deleteCompanyMembershipsMutex.Lock()
	ret, specificReturn := fake.deleteCompanyMembershipsReturnsOnCall[len(fake.deleteCompanyMembershipsArgsForCall)]
	fake.deleteCompanyMembershipsArgsForCall = append(fake.deleteCompanyMembershipsArgsForCall, struct {
		ctx       context.Context
		companyID string
	}{ctx, companyID})
	fake.recordInvocation("DeleteCompanyMemberships", []interface{}{ctx, companyID})
	fake.deleteCompanyMembershipsMutex.Unlock()
	if fake.DeleteCompanyMembershipsStub != nil {
		return fake.DeleteCompanyMembershipsStub(ctx, companyID)
	}
	if specificReturn {
		return ret.result1
	}
	return fake.deleteCompanyMembershipsReturns.result1
}

func (fake *FakeMemberships) DeleteCompanyMembershipsCallCount() int {
	fake.deleteCompanyMembershipsMutex.RLock()
	defer fake.deleteCompanyMembershipsMutex.RUnlock()
	return len(fake.deleteCompanyMembershipsArgsForCall)
}

func (fake *FakeMemberships) DeleteCompanyMembershipsArgsForCall(i int) (context.Context, string) {
	fake.deleteCompanyMembershipsMutex.RLock()
	defer fake.deleteCompanyMembershipsMutex.RUnlock()
	return fake.deleteCompanyMembershipsArgsForCall[i].ctx, fake.deleteCompanyMembershipsArgsForCall[i].companyID
}

func (fake *FakeMemberships) DeleteCompanyMembershipsReturns(result1 error) {
	fake.DeleteCompanyMembershipsStub = nil
	fake.deleteCompanyMembershipsReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeMemberships) DeleteCompanyMembershipsReturnsOnCall(i int, result1 error) {
	fake.DeleteCompanyMembershipsStub = nil
	if fake.deleteCompanyMembershipsReturnsOnCall == nil {
		fake.deleteCompanyMembershipsReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.deleteCompanyMembershipsReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeMemberships) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.getMembershipMutex.RLock()
	defer fake.getMembershipMutex.RUnlock()
	fake.listMembershipsMutex.RLock()
	defer fake.listMembershipsMutex.RUnlock()
	fake.insertMembershipMutex.RLock()
	defer fake.insertMembershipMutex.RUnlock()
	fake.updateMembershipMutex.RLock()
	defer fake.updateMembershipMutex.RUnlock()
	fake.deleteMembershipMutex.RLock()
	defer fake.deleteMembershipMutex.RUnlock()
	fake.getAdminsByCompanyMutex.RLock()
	defer fake.getAdminsByCompanyMutex.RUnlock()
	fake.getMembershipsByAccountMutex.RLock()
	defer fake.getMembershipsByAccountMutex.RUnlock()
	fake.migrateOwnerMutex.RLock()
	defer fake.migrateOwnerMutex.RUnlock()
	fake.deleteCompanyMembershipsMutex.RLock()
	defer fake.deleteCompanyMembershipsMutex.RUnlock()
	return fake.invocations
}

func (fake *FakeMemberships) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ memberships.Memberships = new(FakeMemberships)
