// Code generated by counterfeiter. DO NOT EDIT.
package kmsclientfakes

import (
	"sync"

	"code.justin.tv/devrel/devsite-rbac/clients/kmsclient"
	"github.com/aws/aws-sdk-go/service/kms"
)

type FakeKmsClient struct {
	DecryptStub        func(input *kms.DecryptInput) (*kms.DecryptOutput, error)
	decryptMutex       sync.RWMutex
	decryptArgsForCall []struct {
		input *kms.DecryptInput
	}
	decryptReturns struct {
		result1 *kms.DecryptOutput
		result2 error
	}
	decryptReturnsOnCall map[int]struct {
		result1 *kms.DecryptOutput
		result2 error
	}
	GenerateDataKeyStub        func() (*kms.GenerateDataKeyOutput, error)
	generateDataKeyMutex       sync.RWMutex
	generateDataKeyArgsForCall []struct{}
	generateDataKeyReturns     struct {
		result1 *kms.GenerateDataKeyOutput
		result2 error
	}
	generateDataKeyReturnsOnCall map[int]struct {
		result1 *kms.GenerateDataKeyOutput
		result2 error
	}
	GetKeyARNStub        func() string
	getKeyARNMutex       sync.RWMutex
	getKeyARNArgsForCall []struct{}
	getKeyARNReturns     struct {
		result1 string
	}
	getKeyARNReturnsOnCall map[int]struct {
		result1 string
	}
	GetRegionStub        func() string
	getRegionMutex       sync.RWMutex
	getRegionArgsForCall []struct{}
	getRegionReturns     struct {
		result1 string
	}
	getRegionReturnsOnCall map[int]struct {
		result1 string
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeKmsClient) Decrypt(input *kms.DecryptInput) (*kms.DecryptOutput, error) {
	fake.decryptMutex.Lock()
	ret, specificReturn := fake.decryptReturnsOnCall[len(fake.decryptArgsForCall)]
	fake.decryptArgsForCall = append(fake.decryptArgsForCall, struct {
		input *kms.DecryptInput
	}{input})
	fake.recordInvocation("Decrypt", []interface{}{input})
	fake.decryptMutex.Unlock()
	if fake.DecryptStub != nil {
		return fake.DecryptStub(input)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.decryptReturns.result1, fake.decryptReturns.result2
}

func (fake *FakeKmsClient) DecryptCallCount() int {
	fake.decryptMutex.RLock()
	defer fake.decryptMutex.RUnlock()
	return len(fake.decryptArgsForCall)
}

func (fake *FakeKmsClient) DecryptArgsForCall(i int) *kms.DecryptInput {
	fake.decryptMutex.RLock()
	defer fake.decryptMutex.RUnlock()
	return fake.decryptArgsForCall[i].input
}

func (fake *FakeKmsClient) DecryptReturns(result1 *kms.DecryptOutput, result2 error) {
	fake.DecryptStub = nil
	fake.decryptReturns = struct {
		result1 *kms.DecryptOutput
		result2 error
	}{result1, result2}
}

func (fake *FakeKmsClient) DecryptReturnsOnCall(i int, result1 *kms.DecryptOutput, result2 error) {
	fake.DecryptStub = nil
	if fake.decryptReturnsOnCall == nil {
		fake.decryptReturnsOnCall = make(map[int]struct {
			result1 *kms.DecryptOutput
			result2 error
		})
	}
	fake.decryptReturnsOnCall[i] = struct {
		result1 *kms.DecryptOutput
		result2 error
	}{result1, result2}
}

func (fake *FakeKmsClient) GenerateDataKey() (*kms.GenerateDataKeyOutput, error) {
	fake.generateDataKeyMutex.Lock()
	ret, specificReturn := fake.generateDataKeyReturnsOnCall[len(fake.generateDataKeyArgsForCall)]
	fake.generateDataKeyArgsForCall = append(fake.generateDataKeyArgsForCall, struct{}{})
	fake.recordInvocation("GenerateDataKey", []interface{}{})
	fake.generateDataKeyMutex.Unlock()
	if fake.GenerateDataKeyStub != nil {
		return fake.GenerateDataKeyStub()
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.generateDataKeyReturns.result1, fake.generateDataKeyReturns.result2
}

func (fake *FakeKmsClient) GenerateDataKeyCallCount() int {
	fake.generateDataKeyMutex.RLock()
	defer fake.generateDataKeyMutex.RUnlock()
	return len(fake.generateDataKeyArgsForCall)
}

func (fake *FakeKmsClient) GenerateDataKeyReturns(result1 *kms.GenerateDataKeyOutput, result2 error) {
	fake.GenerateDataKeyStub = nil
	fake.generateDataKeyReturns = struct {
		result1 *kms.GenerateDataKeyOutput
		result2 error
	}{result1, result2}
}

func (fake *FakeKmsClient) GenerateDataKeyReturnsOnCall(i int, result1 *kms.GenerateDataKeyOutput, result2 error) {
	fake.GenerateDataKeyStub = nil
	if fake.generateDataKeyReturnsOnCall == nil {
		fake.generateDataKeyReturnsOnCall = make(map[int]struct {
			result1 *kms.GenerateDataKeyOutput
			result2 error
		})
	}
	fake.generateDataKeyReturnsOnCall[i] = struct {
		result1 *kms.GenerateDataKeyOutput
		result2 error
	}{result1, result2}
}

func (fake *FakeKmsClient) GetKeyARN() string {
	fake.getKeyARNMutex.Lock()
	ret, specificReturn := fake.getKeyARNReturnsOnCall[len(fake.getKeyARNArgsForCall)]
	fake.getKeyARNArgsForCall = append(fake.getKeyARNArgsForCall, struct{}{})
	fake.recordInvocation("GetKeyARN", []interface{}{})
	fake.getKeyARNMutex.Unlock()
	if fake.GetKeyARNStub != nil {
		return fake.GetKeyARNStub()
	}
	if specificReturn {
		return ret.result1
	}
	return fake.getKeyARNReturns.result1
}

func (fake *FakeKmsClient) GetKeyARNCallCount() int {
	fake.getKeyARNMutex.RLock()
	defer fake.getKeyARNMutex.RUnlock()
	return len(fake.getKeyARNArgsForCall)
}

func (fake *FakeKmsClient) GetKeyARNReturns(result1 string) {
	fake.GetKeyARNStub = nil
	fake.getKeyARNReturns = struct {
		result1 string
	}{result1}
}

func (fake *FakeKmsClient) GetKeyARNReturnsOnCall(i int, result1 string) {
	fake.GetKeyARNStub = nil
	if fake.getKeyARNReturnsOnCall == nil {
		fake.getKeyARNReturnsOnCall = make(map[int]struct {
			result1 string
		})
	}
	fake.getKeyARNReturnsOnCall[i] = struct {
		result1 string
	}{result1}
}

func (fake *FakeKmsClient) GetRegion() string {
	fake.getRegionMutex.Lock()
	ret, specificReturn := fake.getRegionReturnsOnCall[len(fake.getRegionArgsForCall)]
	fake.getRegionArgsForCall = append(fake.getRegionArgsForCall, struct{}{})
	fake.recordInvocation("GetRegion", []interface{}{})
	fake.getRegionMutex.Unlock()
	if fake.GetRegionStub != nil {
		return fake.GetRegionStub()
	}
	if specificReturn {
		return ret.result1
	}
	return fake.getRegionReturns.result1
}

func (fake *FakeKmsClient) GetRegionCallCount() int {
	fake.getRegionMutex.RLock()
	defer fake.getRegionMutex.RUnlock()
	return len(fake.getRegionArgsForCall)
}

func (fake *FakeKmsClient) GetRegionReturns(result1 string) {
	fake.GetRegionStub = nil
	fake.getRegionReturns = struct {
		result1 string
	}{result1}
}

func (fake *FakeKmsClient) GetRegionReturnsOnCall(i int, result1 string) {
	fake.GetRegionStub = nil
	if fake.getRegionReturnsOnCall == nil {
		fake.getRegionReturnsOnCall = make(map[int]struct {
			result1 string
		})
	}
	fake.getRegionReturnsOnCall[i] = struct {
		result1 string
	}{result1}
}

func (fake *FakeKmsClient) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.decryptMutex.RLock()
	defer fake.decryptMutex.RUnlock()
	fake.generateDataKeyMutex.RLock()
	defer fake.generateDataKeyMutex.RUnlock()
	fake.getKeyARNMutex.RLock()
	defer fake.getKeyARNMutex.RUnlock()
	fake.getRegionMutex.RLock()
	defer fake.getRegionMutex.RUnlock()
	return fake.invocations
}

func (fake *FakeKmsClient) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ kmsclient.KmsClient = new(FakeKmsClient)
