# CurseForge Infrastructure

[AWS CDK](https://docs.aws.amazon.com/cdk/latest/guide/getting_started.html#getting_started_install) project to define the infrastructure for CurseForge.

## Requirements

- [Node.js](https://nodejs.org/): Using [nodenv](https://github.com/nodenv/nodenv) is recommended, and will automatically use the correct version of Node. If `nodenv` is not available, use the version of Node specified in `.node-version`.
- Serivce Linked Role for ElasticSearch, this can be created in the panel or with the following command: `aws iam create-service-linked-role --aws-service-name es.amazonaws.com --description "Service-linked role to support ElasticSearch"`

## General commands

- `npm install`: Install and upgrade dependencies. Run this to install dependencies.
- `npm install @aws-cdk/aws-ecs`: Add a new dependency.
- `npm install @aws-cdk/aws-ecs@latest`: Upgrade a package to the latest version. Use caution, you usually have to upgrade all CDK dependencies together. You can replace `latest` with an explicit version, e.g. `0.36.0`.

## CDK commands

You must execute CDK using `npx cdk` to use the project-local version. Do not use any globally installed version of `cdk`.

- `npx cdk ls`: List stacks.
- `npx cdk diff [<Stack>...]`: Compare changes with deployed stacks.
- `npx cdk synth [<Stack>...]`: Emit the synthesized CloudFormation template.
- `npx cdk deploy [<Stack>...]`: Deploy updated stacks.
